
stages:
  - Build
  - Test
  - Lint
  # - Deploy

Build Skaffold Zone:
  stage: Build
  tags:
    - docker
    - linux
  services:
    - docker:dind
  image: gcr.io/k8s-skaffold/skaffold:v1.25.0
  needs: []
  script:
    - export DOCKER_HOST=tcp://docker:2375
    - docker login registry.gitlab.com -u gitlab-ci-token -p $CI_JOB_TOKEN
    - skaffold build -f skaffold.zone.yaml --file-output build-zone-${CI_COMMIT_REF_SLUG}.json
  artifacts:
    expire_in: 1 month
    name: "build-zone-${CI_COMMIT_REF_SLUG}"
    paths:
      - build-zone-${CI_COMMIT_REF_SLUG}.json

Build Skaffold Catalog:
  stage: Build
  tags:
    - docker
    - linux
  services:
    - docker:dind
  image: gcr.io/k8s-skaffold/skaffold:v1.25.0
  needs: []
  script:
    - export DOCKER_HOST=tcp://docker:2375
    - docker login registry.gitlab.com -u gitlab-ci-token -p $CI_JOB_TOKEN
    - skaffold build -f skaffold.catalog.yaml --file-output build-catalog-${CI_COMMIT_REF_SLUG}.json
  artifacts:
    expire_in: 1 month
    name: "build-catalog-${CI_COMMIT_REF_SLUG}"
    paths:
      - build-catalog-${CI_COMMIT_REF_SLUG}.json

Test Management UI:
    stage: Test
    tags:
      - docker
      - linux
    image: cirrusci/flutter:2.2.1
    needs: []
    script:
      - cd management_ui/
      - flutter test --coverage
      - lcov --list coverage/lcov.info
      - genhtml coverage/lcov.info --output=coverage
    artifacts:
      expire_in: 1 month
      paths:
        - coverage
    coverage: /\s*lines\.*:\s*([\d\.]+%)/

Lint Management UI:
    stage: Lint
    tags:
      - docker
      - linux
    image: cirrusci/flutter:2.2.1
    needs: []
    script:
      - cd management_ui/
      - flutter analyze

# .deploy:
#   stage: Deploy
#   tags:
#     - cg-privileged
#     - shell
#   script:
#     - |
#       docker run \
#         -v /var/run/docker.sock:/var/run/docker.sock \
#         -v ${XBRP_CICD_KUBECONFIG}:/root/.kube/config \
#         -v $(pwd):/project \
#         -w /project \
#         gcr.io/k8s-skaffold/skaffold:v1.17.1 \
#           skaffold deploy \
#             --profile ${CI_ENVIRONMENT_NAME} \
#             --namespace xbrp-in2029-${CI_ENVIRONMENT_NAME} \
#             -a build-${CI_COMMIT_REF_SLUG}.json \
#             --status-check

# Deploy staging:
#   extends: .deploy
#   environment:
#     name: staging
#   only:
#     - master

# Deploy prod:
#   extends: .deploy
#   environment:
#     name: prod
#   only:
#     - master
#   when: manual
